#----- 16th Feb 2022 --------#

# 1. remove outlier
def remove_outlier(df, column_name, n_outlier):
    q1 = df[column_name].quantile(n_outlier)
    q3 = df[column_name].quantile(1 - n_outlier)
    iqr = q3 - q1
    lower_tail = q1 - 1.5 * iqr
    upper_tail = q3 + 1.5 * iqr
    print('lower_tail : ', lower_tail, '  upper_tail:', upper_tail)
    def remove_map(data):
        if data > float(upper_tail) or data < float(lower_tail):
            return n_outlier
        else:
            return data
    df['new'] = df[column_name].apply(remove_map)
    df = df.drop(columns = [column_name])
    df.rename(columns={'new': column_name}, inplace=True)
    return df

# 2. get daily mean
def get_daliy_mean(df, target_column):
    frame = df[['DATE', target_column]]
    result_df = frame[['DATE', target_column]].groupby('DATE')[target_column].mean().reset_index().sort_values('DATE')
    result_df.columns = ['DATE','D_Mean']
    return result_df

# 3. get time features
def get_trend_mean(df, n_start_date):
    df['year'] = df.DATE.dt.year - n_start_date
    df['month'] = df.DATE.dt.month
    df['weekofyear'] = df.DATE.dt.weekday
    df['dayofweek'] = df.DATE.map(lambda x:x.dayofweek+1)
    return df